/*
 * _gen/svc-OLPC_Buddy_Info.c - Source for GabbleSvcOLPCBuddyInfo
 *
 *  Copyright (C) 2007 Collabora Limited 
 *
 * This file may be distributed under the same terms as the specification
 * from which it is generated.
 */

#include "_gen/svc-OLPC_Buddy_Info.h"

#include <stdio.h>
#include <stdlib.h>

#include <telepathy-glib/dbus.h>
#include "signals-marshal.h"

const DBusGObjectInfo dbus_glib_gabble_svc_olpc_buddy_info_object_info;
struct _GabbleSvcOLPCBuddyInfoClass {
    GTypeInterface parent_class;
    gabble_svc_olpc_buddy_info_get_activities_impl get_activities;
    gabble_svc_olpc_buddy_info_get_current_activity_impl get_current_activity;
    gabble_svc_olpc_buddy_info_get_properties_impl get_properties;
    gabble_svc_olpc_buddy_info_set_activities_impl set_activities;
    gabble_svc_olpc_buddy_info_set_current_activity_impl set_current_activity;
    gabble_svc_olpc_buddy_info_set_properties_impl set_properties;
};

enum {
    SIGNAL_ActivitiesChanged,
    SIGNAL_CurrentActivityChanged,
    SIGNAL_PropertiesChanged,
    N_SIGNALS
};
static guint signals[N_SIGNALS] = {0};


static void
gabble_svc_olpc_buddy_info_base_init (gpointer klass)
{
  static gboolean initialized = FALSE;

  if (!initialized)
    {
      initialized = TRUE;

      signals[SIGNAL_ActivitiesChanged] =
      g_signal_new ("activities-changed",
                    G_OBJECT_CLASS_TYPE (klass),
                    G_SIGNAL_RUN_LAST | G_SIGNAL_DETAILED,
                    0,
                    NULL, NULL,
                    _gabble_ext_marshal_VOID__UINT_BOXED,
                    G_TYPE_NONE, 2, G_TYPE_UINT, (dbus_g_type_get_collection ("GPtrArray", (dbus_g_type_get_struct ("GValueArray", G_TYPE_STRING, G_TYPE_UINT, G_TYPE_INVALID)))));

      signals[SIGNAL_CurrentActivityChanged] =
      g_signal_new ("current-activity-changed",
                    G_OBJECT_CLASS_TYPE (klass),
                    G_SIGNAL_RUN_LAST | G_SIGNAL_DETAILED,
                    0,
                    NULL, NULL,
                    _gabble_ext_marshal_VOID__UINT_STRING_UINT,
                    G_TYPE_NONE, 3, G_TYPE_UINT, G_TYPE_STRING, G_TYPE_UINT);

      signals[SIGNAL_PropertiesChanged] =
      g_signal_new ("properties-changed",
                    G_OBJECT_CLASS_TYPE (klass),
                    G_SIGNAL_RUN_LAST | G_SIGNAL_DETAILED,
                    0,
                    NULL, NULL,
                    _gabble_ext_marshal_VOID__UINT_BOXED,
                    G_TYPE_NONE, 2, G_TYPE_UINT, (dbus_g_type_get_map ("GHashTable", G_TYPE_STRING, G_TYPE_VALUE)));

      dbus_g_object_type_install_info (gabble_svc_olpc_buddy_info_get_type (), &dbus_glib_gabble_svc_olpc_buddy_info_object_info);
    }
}

GType
gabble_svc_olpc_buddy_info_get_type (void)
{
  static GType type = 0;

  if (G_UNLIKELY (type == 0)) {
    static const GTypeInfo info = {
      sizeof (GabbleSvcOLPCBuddyInfoClass),
      gabble_svc_olpc_buddy_info_base_init, /* base_init */
      NULL, /* base_finalize */
      NULL, /* class_init */
      NULL, /* class_finalize */
      NULL, /* class_data */
      0,
      0, /* n_preallocs */
      NULL /* instance_init */
    };

    type = g_type_register_static (G_TYPE_INTERFACE, "GabbleSvcOLPCBuddyInfo", &info, 0);
  }

  return type;
}


/**
 * gabble_svc_olpc_buddy_info_get_activities_impl
 * @self: The object implementing this interface
 * @contact: FIXME: document args in genginterface
 * @context: The D-Bus invocation context to use to return values
 *           or throw an error.
 *
 * Signature of an implementation of D-Bus method GetActivities
 * on interface org.laptop.Telepathy.BuddyInfo
 */
static void
gabble_svc_olpc_buddy_info_get_activities (GabbleSvcOLPCBuddyInfo *self,
                                           guint contact,
                                           DBusGMethodInvocation *context)
{
  gabble_svc_olpc_buddy_info_get_activities_impl impl = (GABBLE_SVC_OLPC_BUDDY_INFO_GET_CLASS (self)->get_activities);
  if (impl)
    (impl) (self, contact, context);
  else
    tp_dbus_g_method_return_not_implemented (context);
}

/**
 * gabble_svc_olpc_buddy_info_implement_get_activities:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the GetActivities method
 *
 * Register an implementation for the GetActivities method in the vtable of an
 * implementation of this interface. To be called from the interface
 * init function.
 */
void
gabble_svc_olpc_buddy_info_implement_get_activities (GabbleSvcOLPCBuddyInfoClass *klass, gabble_svc_olpc_buddy_info_get_activities_impl impl)
{
  klass->get_activities = impl;
}


/**
 * gabble_svc_olpc_buddy_info_get_current_activity_impl
 * @self: The object implementing this interface
 * @contact: FIXME: document args in genginterface
 * @context: The D-Bus invocation context to use to return values
 *           or throw an error.
 *
 * Signature of an implementation of D-Bus method GetCurrentActivity
 * on interface org.laptop.Telepathy.BuddyInfo
 */
static void
gabble_svc_olpc_buddy_info_get_current_activity (GabbleSvcOLPCBuddyInfo *self,
                                                 guint contact,
                                                 DBusGMethodInvocation *context)
{
  gabble_svc_olpc_buddy_info_get_current_activity_impl impl = (GABBLE_SVC_OLPC_BUDDY_INFO_GET_CLASS (self)->get_current_activity);
  if (impl)
    (impl) (self, contact, context);
  else
    tp_dbus_g_method_return_not_implemented (context);
}

/**
 * gabble_svc_olpc_buddy_info_implement_get_current_activity:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the GetCurrentActivity method
 *
 * Register an implementation for the GetCurrentActivity method in the vtable of an
 * implementation of this interface. To be called from the interface
 * init function.
 */
void
gabble_svc_olpc_buddy_info_implement_get_current_activity (GabbleSvcOLPCBuddyInfoClass *klass, gabble_svc_olpc_buddy_info_get_current_activity_impl impl)
{
  klass->get_current_activity = impl;
}


/**
 * gabble_svc_olpc_buddy_info_get_properties_impl
 * @self: The object implementing this interface
 * @contact: FIXME: document args in genginterface
 * @context: The D-Bus invocation context to use to return values
 *           or throw an error.
 *
 * Signature of an implementation of D-Bus method GetProperties
 * on interface org.laptop.Telepathy.BuddyInfo
 */
static void
gabble_svc_olpc_buddy_info_get_properties (GabbleSvcOLPCBuddyInfo *self,
                                           guint contact,
                                           DBusGMethodInvocation *context)
{
  gabble_svc_olpc_buddy_info_get_properties_impl impl = (GABBLE_SVC_OLPC_BUDDY_INFO_GET_CLASS (self)->get_properties);
  if (impl)
    (impl) (self, contact, context);
  else
    tp_dbus_g_method_return_not_implemented (context);
}

/**
 * gabble_svc_olpc_buddy_info_implement_get_properties:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the GetProperties method
 *
 * Register an implementation for the GetProperties method in the vtable of an
 * implementation of this interface. To be called from the interface
 * init function.
 */
void
gabble_svc_olpc_buddy_info_implement_get_properties (GabbleSvcOLPCBuddyInfoClass *klass, gabble_svc_olpc_buddy_info_get_properties_impl impl)
{
  klass->get_properties = impl;
}


/**
 * gabble_svc_olpc_buddy_info_set_activities_impl
 * @self: The object implementing this interface
 * @activities: FIXME: document args in genginterface
 * @context: The D-Bus invocation context to use to return values
 *           or throw an error.
 *
 * Signature of an implementation of D-Bus method SetActivities
 * on interface org.laptop.Telepathy.BuddyInfo
 */
static void
gabble_svc_olpc_buddy_info_set_activities (GabbleSvcOLPCBuddyInfo *self,
                                           const GPtrArray *activities,
                                           DBusGMethodInvocation *context)
{
  gabble_svc_olpc_buddy_info_set_activities_impl impl = (GABBLE_SVC_OLPC_BUDDY_INFO_GET_CLASS (self)->set_activities);
  if (impl)
    (impl) (self, activities, context);
  else
    tp_dbus_g_method_return_not_implemented (context);
}

/**
 * gabble_svc_olpc_buddy_info_implement_set_activities:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the SetActivities method
 *
 * Register an implementation for the SetActivities method in the vtable of an
 * implementation of this interface. To be called from the interface
 * init function.
 */
void
gabble_svc_olpc_buddy_info_implement_set_activities (GabbleSvcOLPCBuddyInfoClass *klass, gabble_svc_olpc_buddy_info_set_activities_impl impl)
{
  klass->set_activities = impl;
}


/**
 * gabble_svc_olpc_buddy_info_set_current_activity_impl
 * @self: The object implementing this interface
 * @activity: FIXME: document args in genginterface
 * @channel: FIXME: document args in genginterface
 * @context: The D-Bus invocation context to use to return values
 *           or throw an error.
 *
 * Signature of an implementation of D-Bus method SetCurrentActivity
 * on interface org.laptop.Telepathy.BuddyInfo
 */
static void
gabble_svc_olpc_buddy_info_set_current_activity (GabbleSvcOLPCBuddyInfo *self,
                                                 const gchar *activity,
                                                 guint channel,
                                                 DBusGMethodInvocation *context)
{
  gabble_svc_olpc_buddy_info_set_current_activity_impl impl = (GABBLE_SVC_OLPC_BUDDY_INFO_GET_CLASS (self)->set_current_activity);
  if (impl)
    (impl) (self, activity, channel, context);
  else
    tp_dbus_g_method_return_not_implemented (context);
}

/**
 * gabble_svc_olpc_buddy_info_implement_set_current_activity:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the SetCurrentActivity method
 *
 * Register an implementation for the SetCurrentActivity method in the vtable of an
 * implementation of this interface. To be called from the interface
 * init function.
 */
void
gabble_svc_olpc_buddy_info_implement_set_current_activity (GabbleSvcOLPCBuddyInfoClass *klass, gabble_svc_olpc_buddy_info_set_current_activity_impl impl)
{
  klass->set_current_activity = impl;
}


/**
 * gabble_svc_olpc_buddy_info_set_properties_impl
 * @self: The object implementing this interface
 * @properties: FIXME: document args in genginterface
 * @context: The D-Bus invocation context to use to return values
 *           or throw an error.
 *
 * Signature of an implementation of D-Bus method SetProperties
 * on interface org.laptop.Telepathy.BuddyInfo
 */
static void
gabble_svc_olpc_buddy_info_set_properties (GabbleSvcOLPCBuddyInfo *self,
                                           GHashTable *properties,
                                           DBusGMethodInvocation *context)
{
  gabble_svc_olpc_buddy_info_set_properties_impl impl = (GABBLE_SVC_OLPC_BUDDY_INFO_GET_CLASS (self)->set_properties);
  if (impl)
    (impl) (self, properties, context);
  else
    tp_dbus_g_method_return_not_implemented (context);
}

/**
 * gabble_svc_olpc_buddy_info_implement_set_properties:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the SetProperties method
 *
 * Register an implementation for the SetProperties method in the vtable of an
 * implementation of this interface. To be called from the interface
 * init function.
 */
void
gabble_svc_olpc_buddy_info_implement_set_properties (GabbleSvcOLPCBuddyInfoClass *klass, gabble_svc_olpc_buddy_info_set_properties_impl impl)
{
  klass->set_properties = impl;
}

/**
 * gabble_svc_olpc_buddy_info_emit_activities_changed:
 * @instance: An object implementing this interface
 * @contact: FIXME: document args in genginterface
 * @activities: FIXME: document args in genginterface
 *
 * Emit the ActivitiesChanged D-Bus signal from @instance with the given arguments.
 */
void gabble_svc_olpc_buddy_info_emit_activities_changed (gpointer instance,
    const guint  contact,
    const GPtrArray * activities)
{
  g_assert (GABBLE_IS_SVC_OLPC_BUDDY_INFO (instance));
  g_signal_emit (instance, signals[SIGNAL_ActivitiesChanged], 0, contact, activities);
}

/**
 * gabble_svc_olpc_buddy_info_emit_current_activity_changed:
 * @instance: An object implementing this interface
 * @contact: FIXME: document args in genginterface
 * @activity: FIXME: document args in genginterface
 * @channel: FIXME: document args in genginterface
 *
 * Emit the CurrentActivityChanged D-Bus signal from @instance with the given arguments.
 */
void gabble_svc_olpc_buddy_info_emit_current_activity_changed (gpointer instance,
    const guint  contact,
    const gchar * activity,
    const guint  channel)
{
  g_assert (GABBLE_IS_SVC_OLPC_BUDDY_INFO (instance));
  g_signal_emit (instance, signals[SIGNAL_CurrentActivityChanged], 0, contact, activity, channel);
}

/**
 * gabble_svc_olpc_buddy_info_emit_properties_changed:
 * @instance: An object implementing this interface
 * @contact: FIXME: document args in genginterface
 * @properties: FIXME: document args in genginterface
 *
 * Emit the PropertiesChanged D-Bus signal from @instance with the given arguments.
 */
void gabble_svc_olpc_buddy_info_emit_properties_changed (gpointer instance,
    const guint  contact,
    const GHashTable * properties)
{
  g_assert (GABBLE_IS_SVC_OLPC_BUDDY_INFO (instance));
  g_signal_emit (instance, signals[SIGNAL_PropertiesChanged], 0, contact, properties);
}

#include "_gen/svc-OLPC_Buddy_Info-glue.h"

